


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for resources/Atividade.py: 68%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>resources/Atividade.py</b> :
            <span class="pc_cov">68%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            111 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">75 run</span>
            <span class="mis shortkey_m button_toggle_mis">36 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="stm run hide_run"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="stm run hide_run"><a href="#n3">3</a></p>
<p id="n4" class="stm run hide_run"><a href="#n4">4</a></p>
<p id="n5" class="stm run hide_run"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="stm run hide_run"><a href="#n7">7</a></p>
<p id="n8" class="stm run hide_run"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="stm run hide_run"><a href="#n10">10</a></p>
<p id="n11" class="stm run hide_run"><a href="#n11">11</a></p>
<p id="n12" class="stm run hide_run"><a href="#n12">12</a></p>
<p id="n13" class="stm run hide_run"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="stm run hide_run"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm mis"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="stm mis"><a href="#n31">31</a></p>
<p id="n32" class="stm mis"><a href="#n32">32</a></p>
<p id="n33" class="stm run hide_run"><a href="#n33">33</a></p>
<p id="n34" class="pln"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="stm run hide_run"><a href="#n36">36</a></p>
<p id="n37" class="stm run hide_run"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm run hide_run"><a href="#n40">40</a></p>
<p id="n41" class="stm run hide_run"><a href="#n41">41</a></p>
<p id="n42" class="stm run hide_run"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="stm mis"><a href="#n46">46</a></p>
<p id="n47" class="stm run hide_run"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="pln"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="stm run hide_run"><a href="#n52">52</a></p>
<p id="n53" class="stm run hide_run"><a href="#n53">53</a></p>
<p id="n54" class="stm run hide_run"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="stm mis"><a href="#n57">57</a></p>
<p id="n58" class="stm mis"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="stm run hide_run"><a href="#n62">62</a></p>
<p id="n63" class="stm run hide_run"><a href="#n63">63</a></p>
<p id="n64" class="stm run hide_run"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="stm run hide_run"><a href="#n66">66</a></p>
<p id="n67" class="stm run hide_run"><a href="#n67">67</a></p>
<p id="n68" class="stm run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="stm run hide_run"><a href="#n70">70</a></p>
<p id="n71" class="pln"><a href="#n71">71</a></p>
<p id="n72" class="stm run hide_run"><a href="#n72">72</a></p>
<p id="n73" class="stm run hide_run"><a href="#n73">73</a></p>
<p id="n74" class="stm run hide_run"><a href="#n74">74</a></p>
<p id="n75" class="stm run hide_run"><a href="#n75">75</a></p>
<p id="n76" class="pln"><a href="#n76">76</a></p>
<p id="n77" class="stm run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="stm run hide_run"><a href="#n78">78</a></p>
<p id="n79" class="stm run hide_run"><a href="#n79">79</a></p>
<p id="n80" class="stm run hide_run"><a href="#n80">80</a></p>
<p id="n81" class="stm run hide_run"><a href="#n81">81</a></p>
<p id="n82" class="stm run hide_run"><a href="#n82">82</a></p>
<p id="n83" class="stm run hide_run"><a href="#n83">83</a></p>
<p id="n84" class="stm run hide_run"><a href="#n84">84</a></p>
<p id="n85" class="stm run hide_run"><a href="#n85">85</a></p>
<p id="n86" class="stm run hide_run"><a href="#n86">86</a></p>
<p id="n87" class="stm run hide_run"><a href="#n87">87</a></p>
<p id="n88" class="stm mis"><a href="#n88">88</a></p>
<p id="n89" class="stm mis"><a href="#n89">89</a></p>
<p id="n90" class="stm mis"><a href="#n90">90</a></p>
<p id="n91" class="stm mis"><a href="#n91">91</a></p>
<p id="n92" class="stm run hide_run"><a href="#n92">92</a></p>
<p id="n93" class="stm run hide_run"><a href="#n93">93</a></p>
<p id="n94" class="stm mis"><a href="#n94">94</a></p>
<p id="n95" class="stm run hide_run"><a href="#n95">95</a></p>
<p id="n96" class="stm run hide_run"><a href="#n96">96</a></p>
<p id="n97" class="stm run hide_run"><a href="#n97">97</a></p>
<p id="n98" class="stm run hide_run"><a href="#n98">98</a></p>
<p id="n99" class="stm run hide_run"><a href="#n99">99</a></p>
<p id="n100" class="stm run hide_run"><a href="#n100">100</a></p>
<p id="n101" class="stm mis"><a href="#n101">101</a></p>
<p id="n102" class="stm mis"><a href="#n102">102</a></p>
<p id="n103" class="stm mis"><a href="#n103">103</a></p>
<p id="n104" class="stm run hide_run"><a href="#n104">104</a></p>
<p id="n105" class="stm run hide_run"><a href="#n105">105</a></p>
<p id="n106" class="stm run hide_run"><a href="#n106">106</a></p>
<p id="n107" class="stm run hide_run"><a href="#n107">107</a></p>
<p id="n108" class="stm mis"><a href="#n108">108</a></p>
<p id="n109" class="stm mis"><a href="#n109">109</a></p>
<p id="n110" class="stm mis"><a href="#n110">110</a></p>
<p id="n111" class="stm run hide_run"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="stm run hide_run"><a href="#n114">114</a></p>
<p id="n115" class="stm run hide_run"><a href="#n115">115</a></p>
<p id="n116" class="stm run hide_run"><a href="#n116">116</a></p>
<p id="n117" class="stm run hide_run"><a href="#n117">117</a></p>
<p id="n118" class="pln"><a href="#n118">118</a></p>
<p id="n119" class="stm mis"><a href="#n119">119</a></p>
<p id="n120" class="stm mis"><a href="#n120">120</a></p>
<p id="n121" class="stm mis"><a href="#n121">121</a></p>
<p id="n122" class="stm mis"><a href="#n122">122</a></p>
<p id="n123" class="stm mis"><a href="#n123">123</a></p>
<p id="n124" class="stm mis"><a href="#n124">124</a></p>
<p id="n125" class="stm mis"><a href="#n125">125</a></p>
<p id="n126" class="stm mis"><a href="#n126">126</a></p>
<p id="n127" class="stm mis"><a href="#n127">127</a></p>
<p id="n128" class="stm mis"><a href="#n128">128</a></p>
<p id="n129" class="stm mis"><a href="#n129">129</a></p>
<p id="n130" class="stm mis"><a href="#n130">130</a></p>

            </td>
            <td class="text">
<p id="t1" class="stm run hide_run"><span class="key">import</span> <span class="nam">sys</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t3" class="stm run hide_run"><span class="key">import</span> <span class="nam">flask</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="stm run hide_run"><span class="key">from</span> <span class="nam">flask_restplus</span> <span class="key">import</span> <span class="nam">abort</span><span class="op">,</span> <span class="nam">Namespace</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="stm run hide_run"><span class="key">from</span> <span class="nam">sqlalchemy</span><span class="op">.</span><span class="nam">exc</span> <span class="key">import</span> <span class="nam">DatabaseError</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t7" class="stm run hide_run"><span class="key">from</span> <span class="nam">app</span> <span class="key">import</span> <span class="nam">db</span><span class="op">,</span> <span class="nam">Resource</span><span class="op">,</span> <span class="nam">request</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="stm run hide_run"><span class="key">from</span> <span class="nam">http</span> <span class="key">import</span> <span class="nam">HTTPStatus</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t10" class="stm run hide_run"><span class="key">from</span> <span class="nam">auth</span><span class="op">.</span><span class="nam">AuthLevel</span> <span class="key">import</span> <span class="nam">AuthLevel</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="stm run hide_run"><span class="key">from</span> <span class="nam">auth</span><span class="op">.</span><span class="nam">authorize</span> <span class="key">import</span> <span class="nam">check_authorization</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="stm run hide_run"><span class="key">from</span> <span class="nam">models</span> <span class="key">import</span> <span class="nam">Atividade</span><span class="op">,</span> <span class="nam">TipoAtividade</span><span class="op">,</span> <span class="nam">Evento</span><span class="op">,</span> <span class="nam">Local</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="stm run hide_run"><span class="key">from</span> <span class="nam">auth</span><span class="op">.</span><span class="nam">authenticate</span> <span class="key">import</span> <span class="nam">authenticate_or_abort</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t15" class="stm run hide_run"><span class="nam">atividade_ns</span> <span class="op">=</span> <span class="nam">Namespace</span><span class="op">(</span><span class="nam">name</span><span class="op">=</span><span class="str">"atividade"</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">"Rotas relacionadas a atividades"</span><span class="op">,</span> <span class="nam">path</span><span class="op">=</span><span class="str">"/atividade"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">'/&lt;id>'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">class</span> <span class="nam">AtividadeResource</span><span class="op">(</span><span class="nam">Resource</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">Atividade</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">response</span><span class="op">(</span><span class="nam">code</span><span class="op">=</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">"Nenhuma atividade registrada com esse id"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln">    <span class="key">def</span> <span class="nam">get</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">id</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run">        <span class="nam">atividade</span> <span class="op">=</span> <span class="nam">Atividade</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">id</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run">        <span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span> <span class="op">=</span> <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run">        <span class="key">if</span> <span class="nam">atividade</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run">            <span class="key">return</span> <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run">            <span class="nam">check_authorization</span><span class="op">(</span><span class="nam">atividade</span><span class="op">.</span><span class="nam">id_evento</span><span class="op">,</span> <span class="nam">AuthLevel</span><span class="op">.</span><span class="nam">PARTICIPANTE</span><span class="op">,</span> <span class="nam">access_token</span><span class="op">=</span><span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span><span class="op">=</span><span class="nam">uid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm mis">        <span class="key">except</span> <span class="op">(</span><span class="nam">ValueError</span><span class="op">,</span> <span class="nam">AssertionError</span><span class="op">)</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">UNAUTHORIZED</span><span class="op">,</span> <span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm mis">        <span class="key">except</span> <span class="nam">RuntimeError</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">INTERNAL_SERVER_ERROR</span><span class="op">,</span> <span class="nam">str</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm run hide_run">        <span class="key">return</span> <span class="nam">atividade</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run">    <span class="key">def</span> <span class="nam">delete</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">id</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm run hide_run">        <span class="nam">atividade</span> <span class="op">=</span> <span class="nam">Atividade</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">id</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm run hide_run">        <span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span> <span class="op">=</span> <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run">        <span class="key">if</span> <span class="nam">atividade</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">            <span class="key">return</span> <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm run hide_run">        <span class="nam">evento_id</span> <span class="op">=</span> <span class="nam">atividade</span><span class="op">.</span><span class="nam">evento</span><span class="op">.</span><span class="nam">id</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm run hide_run">            <span class="nam">check_authorization</span><span class="op">(</span><span class="nam">evento_id</span><span class="op">,</span> <span class="nam">AuthLevel</span><span class="op">.</span><span class="nam">ADMIN</span><span class="op">,</span> <span class="nam">access_token</span><span class="op">=</span><span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span><span class="op">=</span><span class="nam">uid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">        <span class="key">except</span> <span class="op">(</span><span class="nam">ValueError</span><span class="op">,</span> <span class="nam">AssertionError</span><span class="op">)</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">UNAUTHORIZED</span><span class="op">,</span> <span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">        <span class="key">except</span> <span class="nam">RuntimeError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">INTERNAL_SERVER_ERROR</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm run hide_run">        <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">delete</span><span class="op">(</span><span class="nam">atividade</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run">        <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">commit</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run"><span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">'/&lt;id>/tipo'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm run hide_run"><span class="key">class</span> <span class="nam">AtividadeTipoResource</span><span class="op">(</span><span class="nam">Resource</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">TipoAtividade</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">response</span><span class="op">(</span><span class="nam">code</span><span class="op">=</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">"Nenhuma atividade registrada com esse id"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln">    <span class="key">def</span> <span class="nam">get</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">id</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">        <span class="nam">atividade</span> <span class="op">=</span> <span class="nam">Atividade</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">id</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm mis">        <span class="key">if</span> <span class="nam">atividade</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm mis">            <span class="key">return</span> <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">        <span class="key">return</span> <span class="nam">atividade</span><span class="op">.</span><span class="nam">tipo</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm run hide_run"><span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm run hide_run"><span class="key">class</span> <span class="nam">AtividadesResource</span><span class="op">(</span><span class="nam">Resource</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">Atividade</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln">    <span class="key">def</span> <span class="nam">get</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm run hide_run">        <span class="nam">atividades</span> <span class="op">=</span> <span class="nam">Atividade</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">all</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm run hide_run">        <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm run hide_run">        <span class="key">if</span> <span class="nam">atividades</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">            <span class="key">return</span> <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm run hide_run">        <span class="key">return</span> <span class="nam">atividades</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">expect</span><span class="op">(</span><span class="nam">Atividade</span><span class="op">.</span><span class="nam">RequestModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">Atividade</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">response</span><span class="op">(</span><span class="nam">code</span><span class="op">=</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">UNAUTHORIZED</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">"Opera&#231;&#227;o n&#227;o autorizada. Deve estar autenticado!"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">response</span><span class="op">(</span><span class="nam">code</span><span class="op">=</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">"Requisi&#231;&#227;o inv&#225;lida/incorreta."</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="pln">    <span class="key">def</span> <span class="nam">post</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm run hide_run">        <span class="nam">atividade_json</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">get_json</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm run hide_run">        <span class="nam">print</span><span class="op">(</span><span class="str">f"atividade_json: {atividade_json}"</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm run hide_run">        <span class="nam">evento</span> <span class="op">=</span> <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">query</span><span class="op">(</span><span class="nam">Evento</span><span class="op">)</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">atividade_json</span><span class="op">[</span><span class="str">"id_evento"</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm run hide_run">        <span class="nam">local</span> <span class="op">=</span> <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">query</span><span class="op">(</span><span class="nam">Local</span><span class="op">)</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">atividade_json</span><span class="op">[</span><span class="str">"id_local"</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="stm run hide_run">        <span class="nam">tipo</span> <span class="op">=</span> <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">query</span><span class="op">(</span><span class="nam">TipoAtividade</span><span class="op">)</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">atividade_json</span><span class="op">[</span><span class="str">"id_tipo"</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm run hide_run">        <span class="nam">print</span><span class="op">(</span><span class="str">f"local: {local}"</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="stm run hide_run">        <span class="nam">print</span><span class="op">(</span><span class="str">f"tipo: {tipo}"</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm run hide_run">        <span class="nam">print</span><span class="op">(</span><span class="str">f"evento: {evento}"</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="stm run hide_run">        <span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span> <span class="op">=</span> <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="stm run hide_run">            <span class="nam">check_authorization</span><span class="op">(</span><span class="nam">atividade_json</span><span class="op">[</span><span class="str">"id_evento"</span><span class="op">]</span><span class="op">,</span> <span class="nam">AuthLevel</span><span class="op">.</span><span class="nam">ADMIN</span><span class="op">,</span> <span class="nam">access_token</span><span class="op">=</span><span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span><span class="op">=</span><span class="nam">uid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm mis">        <span class="key">except</span> <span class="op">(</span><span class="nam">ValueError</span><span class="op">,</span> <span class="nam">AssertionError</span><span class="op">)</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">UNAUTHORIZED</span><span class="op">,</span> <span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm mis">        <span class="key">except</span> <span class="nam">RuntimeError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">INTERNAL_SERVER_ERROR</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="stm run hide_run">        <span class="nam">atividade</span><span class="op">,</span> <span class="nam">err</span> <span class="op">=</span> <span class="nam">Atividade</span><span class="op">.</span><span class="nam">Schema</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">load</span><span class="op">(</span><span class="nam">atividade_json</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="stm run hide_run">        <span class="key">if</span> <span class="nam">err</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">,</span> <span class="nam">err</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="stm run hide_run">            <span class="nam">print</span><span class="op">(</span><span class="nam">type</span><span class="op">(</span><span class="nam">atividade</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="stm run hide_run">            <span class="nam">print</span><span class="op">(</span><span class="nam">err</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm run hide_run">            <span class="nam">atividade</span><span class="op">.</span><span class="nam">evento</span> <span class="op">=</span> <span class="nam">evento</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="stm run hide_run">            <span class="nam">atividade</span><span class="op">.</span><span class="nam">local</span> <span class="op">=</span> <span class="nam">local</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="stm run hide_run">            <span class="nam">atividade</span><span class="op">.</span><span class="nam">tipo</span> <span class="op">=</span> <span class="nam">tipo</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="stm mis">        <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm mis">            <span class="nam">print</span><span class="op">(</span><span class="nam">e</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">,</span> <span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="stm run hide_run">        <span class="nam">print</span><span class="op">(</span><span class="nam">atividade</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="stm run hide_run">        <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">add</span><span class="op">(</span><span class="nam">atividade</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="stm run hide_run">            <span class="nam">db</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">commit</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm mis">        <span class="key">except</span> <span class="nam">DatabaseError</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="stm mis">            <span class="nam">print</span><span class="op">(</span><span class="nam">e</span><span class="op">,</span> <span class="nam">file</span><span class="op">=</span><span class="nam">sys</span><span class="op">.</span><span class="nam">stderr</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">BAD_REQUEST</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="stm run hide_run">        <span class="key">return</span> <span class="nam">Atividade</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">order_by</span><span class="op">(</span><span class="nam">Atividade</span><span class="op">.</span><span class="nam">id</span><span class="op">.</span><span class="nam">desc</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">.</span><span class="nam">first</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm run hide_run"><span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/&lt;id>/local"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm run hide_run"><span class="key">class</span> <span class="nam">LocalAtividadeResource</span><span class="op">(</span><span class="nam">Resource</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">marshal_with</span><span class="op">(</span><span class="nam">Local</span><span class="op">.</span><span class="nam">ResponseModel</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm run hide_run">    <span class="op">@</span><span class="nam">atividade_ns</span><span class="op">.</span><span class="nam">response</span><span class="op">(</span><span class="nam">code</span><span class="op">=</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">UNAUTHORIZED</span><span class="op">,</span> <span class="nam">description</span><span class="op">=</span><span class="str">"Opera&#231;&#227;o n&#227;o autorizada. Deve estar autenticado!"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="pln">    <span class="key">def</span> <span class="nam">get</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">id</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm mis">        <span class="nam">atividade</span> <span class="op">=</span> <span class="nam">Atividade</span><span class="op">.</span><span class="nam">query</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="nam">id</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm mis">        <span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span> <span class="op">=</span> <span class="nam">authenticate_or_abort</span><span class="op">(</span><span class="nam">flask</span><span class="op">.</span><span class="nam">request</span><span class="op">.</span><span class="nam">args</span><span class="op">.</span><span class="nam">get</span><span class="op">,</span> <span class="nam">abort</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm mis">        <span class="key">if</span> <span class="nam">atividade</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="stm mis">            <span class="key">return</span> <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">NOT_FOUND</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm mis">        <span class="nam">evento_id</span> <span class="op">=</span> <span class="nam">atividade</span><span class="op">.</span><span class="nam">evento</span><span class="op">.</span><span class="nam">id</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="stm mis">            <span class="nam">check_authorization</span><span class="op">(</span><span class="nam">evento_id</span><span class="op">,</span> <span class="nam">AuthLevel</span><span class="op">.</span><span class="nam">PARTICIPANTE</span><span class="op">,</span> <span class="nam">access_token</span><span class="op">=</span><span class="nam">token</span><span class="op">,</span> <span class="nam">uid</span><span class="op">=</span><span class="nam">uid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm mis">        <span class="key">except</span> <span class="op">(</span><span class="nam">ValueError</span><span class="op">,</span> <span class="nam">AssertionError</span><span class="op">)</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">UNAUTHORIZED</span><span class="op">,</span> <span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="stm mis">        <span class="key">except</span> <span class="nam">RuntimeError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="stm mis">            <span class="nam">abort</span><span class="op">(</span><span class="nam">HTTPStatus</span><span class="op">.</span><span class="nam">INTERNAL_SERVER_ERROR</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="stm mis">        <span class="key">return</span> <span class="nam">atividade</span><span class="op">.</span><span class="nam">local</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-18 17:47
        </p>
    </div>
</div>

</body>
</html>
